=== debian/changelog ===
pcl-1.7 (1.7.0-2+precise2) precise; urgency=low

  * Change OpenNI dependencies to openni-dev and ps-engine to be compatible
    with old versions.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 14 Aug 2013 17:21:51 +0200

pcl-1.7 (1.7.0-2+precise1) precise; urgency=low

  * Fix typo (features instead of feature).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 14 Aug 2013 09:51:18 +0200

pcl-1.7 (1.7.0-1+precise2) precise; urgency=low

  * Add 0001-Use-__SSE__-instead-of-HAVE_SSE_EXTENSIONS.patch to fix compiler
    error.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 13 Aug 2013 17:01:49 +0200

pcl-1.7 (1.7.0-1+precise1) precise; urgency=low

  * New upstream release.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 13 Aug 2013 09:11:53 +0200

pcl-1.6 (1:1.6.0-1+raring2) raring; urgency=low

  * Change dependencies from ps-engine to libopenni-sensor-primesense0.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 20 May 2013 09:58:45 +0200

pcl-1.6 (1:1.6.0-1+raring1) raring; urgency=low

  * Upload to raring.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sun, 19 May 2013 10:45:56 +0200

pcl-1.6 (1:1.6.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Add epoch because I've used the wrong version number for the release
    candidate.
  * Change build dependency from libflann1.7-dev to libflann-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 18 Jul 2012 04:02:23 +0200

pcl-1.6 (1.6.0rc1-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Add new libpcl-geometry lib.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 07 Jul 2012 10:28:27 +0200

pcl-1.5 (1.5.1-1+quantal3) quantal; urgency=low

  * Fix c&p error in doxygen generation.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 28 Feb 2012 09:22:22 +0100

pcl-1.5 (1.5.1-1+quantal2) quantal; urgency=low

  * Fix doxygen generation (wrong make path).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 27 Feb 2012 17:38:19 +0100

pcl-1.5 (1.5.1-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Add libpcl_io_ply.so to libpcl-io.
  * Fix location of documentation.
  * Integrated pcl_rage_image into pcl_common.
  * Set -DCMAKE_BUILD_TYPE=Debug to only build with system build flags.
  * Add new libpcl-tracking lib.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Thu, 23 Feb 2012 01:50:08 +0100

pcl-1.4 (1.4.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Bump Flann dependency to libflann1.7-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 03 Jan 2012 17:51:51 +0100

pcl-1.3 (1.3.1a-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Please note that this is the "new" 1.3.1 release as of 03 Dec 2011 because
    upstream decided to release it again, hence the epoch.
  * Removed superfluous dependency on libboost-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 03 Dec 2011 17:36:09 +0100

pcl-1.3 (1.3.1-1+quantal1) quantal; urgency=low

  * New upstream release.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Thu, 03 Nov 2011 19:26:52 +0100

pcl-1.3 (1.3.0-1+quantal3) quantal; urgency=low

  * Add conflicts against PCL 1.2.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Thu, 03 Nov 2011 09:34:19 +0100

pcl-1.3 (1.3.0-1+quantal2) quantal; urgency=low

  * Add Boost iostreams as dependency.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 02 Nov 2011 21:56:10 +0100

pcl-1.3 (1.3.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * remove fix_pkgconfig patch (merged upstream).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 02 Nov 2011 17:42:09 +0100

pcl-1.2 (1.2.0-1+quantal8) quantal; urgency=low

  * Accidentally removed Boost dependencies (again)

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 29 Oct 2011 20:04:13 +0200

pcl-1.2 (1.2.0-1+quantal7) quantal; urgency=low

  * Fix typo in pkg-config file (thanks Bastian).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 29 Oct 2011 16:52:50 +0200

pcl-1.2 (1.2.0-1+quantal6) quantal; urgency=low

  * Fixed typo in control file.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 04 Oct 2011 07:38:31 +0200

pcl-1.2 (1.2.0-1+quantal5) quantal; urgency=low

  * Accidentally removed Boost dependencies.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Tue, 04 Oct 2011 07:08:43 +0200

pcl-1.2 (1.2.0-1+quantal4) quantal; urgency=low

  * Hack around old debhelper in Debian to make documentation compile (see
    rules).

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 03 Oct 2011 23:08:13 +0200

pcl-1.2 (1.2.0-1+quantal3) quantal; urgency=low

  * Added python-sphinx as build dependency (needed for
    -DBUILD_documentation=ON but not used).
  * Unversion Boost dependency (given that we use a different version of
    OpenNI than ROS we are incompatible with it anyhow, so there is no point
    in sticking with the same Boost version as in ROS).
  * Only depend on system filesystem thread and date_time of Boost.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 03 Oct 2011 09:37:13 +0200

pcl-1.2 (1.2.0-1+quantal2) quantal; urgency=low

  * Fix libpcl-filtering-1.2-dev -> libpcl-filters-1.2-dev.
  * Fix libpcl-feature-1.2-dev -> libpcl-features-1.2-dev.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Mon, 03 Oct 2011 00:01:25 +0200

pcl-1.2 (1.2.0-1+quantal1) quantal; urgency=low

  * New upstream release.
  * Added doc package with doxygen documentation.
  * Split into separate packages.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Sat, 01 Oct 2011 17:41:49 +0200

pcl-1.1 (1.1.1-1+quantal1) quantal; urgency=low

  * New upstream release.

 -- Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>  Wed, 31 Aug 2011 23:15:17 +0200


