=== debian/control ===
Source: pcl-1.7
Priority: optional
Maintainer: Jochen Sprickerhof <launchpad@jochen.sprickerhof.de>
Build-Depends: debhelper (>= 9), cmake, libboost-system-dev, libboost-filesystem-dev, libboost-thread-dev, libboost-date-time-dev, libboost-iostreams-dev, libeigen3-dev, libflann-dev, libusb-1.0-0-dev, openni-dev, libpng12-dev, libqhull-dev, libvtk5-qt4-dev, doxygen-latex, python-sphinx
Standards-Version: 3.9.1
Section: libs
Homepage: http://pointclouds.org/

Package: libpcl-1.7-all
Section: devel
Architecture: all
Depends: ${misc:Depends}, libpcl-1.7-all-dev, libpcl-1.7-bin, libpcl-1.7-doc
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package depends on all PCL packages.

Package: libpcl-1.7-all-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, libpcl-apps-1.7-dev, libpcl-common-1.7-dev, libpcl-features-1.7-dev, libpcl-filters-1.7-dev, libpcl-geometry-1.7-dev, libpcl-io-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-keypoints-1.7-dev, libpcl-octree-1.7-dev, libpcl-outofcore-1.7-dev, libpcl-people-1.7-dev, libpcl-recognition-1.7-dev, libpcl-registration-1.7-dev, libpcl-sample-consensus-1.7-dev, libpcl-search-1.7-dev, libpcl-segmentation-1.7-dev, libpcl-surface-1.7-dev, libpcl-tracking-1.7-dev, libpcl-visualization-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package depends on all PCL development packages.

Package: libpcl-apps-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-apps-1.3-dev, libpcl-apps-1.4-dev, libpcl-apps-1.5-dev, libpcl-apps-1.6-dev
Depends: libpcl-apps-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-geometry-1.7-dev, libpcl-io-1.7-dev, libpcl-filters-1.7-dev, libpcl-sample-consensus-1.7-dev, libpcl-segmentation-1.7-dev, libpcl-visualization-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-features-1.7-dev, libpcl-surface-1.7-dev, libpcl-octree-1.7-dev, libpcl-registration-1.7-dev, libpcl-keypoints-1.7-dev, libpcl-tracking-1.7-dev, libpcl-search-1.7-dev, libpcl-recognition-1.7-dev, openni-dev, libvtk5-qt4-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL apps.

Package: libpcl-apps-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL apps.

Package: libpcl-common-1.7-dev
Section: libdevel
Architecture: any
Depends: libpcl-common-1.7 (= ${binary:Version}), ${misc:Depends}, libeigen3-dev, libboost-system-dev, libboost-filesystem-dev, libboost-thread-dev, libboost-date-time-dev, libboost-iostreams-dev
Suggests: cmake, libpcl-1.7-doc
Conflicts: libpcl-1.0-dev, libpcl-1.1-dev, libpcl-common-1.2-dev, libpcl-common-1.3-dev, libpcl-common-1.4-dev, libpcl-common-1.5-dev, libpcl-common-1.6-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL common.

Package: libpcl-common-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL common.

Package: libpcl-1.7-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the doxygen documentation of PCL.

Package: libpcl-features-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-features-1.2-dev, libpcl-features-1.3-dev, libpcl-features-1.4-dev, libpcl-features-1.5-dev, libpcl-features-1.6-dev
Depends: libpcl-features-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-search-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-octree-1.7-dev, libpcl-filters-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL features.

Package: libpcl-features-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL features.

Package: libpcl-filters-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-filters-1.2-dev, libpcl-filters-1.3-dev, libpcl-filters-1.4-dev, libpcl-filters-1.5-dev, libpcl-filters-1.6-dev
Depends: libpcl-filters-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-sample-consensus-1.7-dev, libpcl-search-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-octree-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL filters.

Package: libpcl-filters-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL filters.

Package: libpcl-geometry-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-geometry-1.6-dev
Depends: ${misc:Depends}, libpcl-common-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL geometry.

Package: libpcl-io-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-io-1.2-dev, libpcl-io-1.3-dev, libpcl-io-1.4-dev, libpcl-io-1.5-dev, libpcl-io-1.6-dev
Depends: libpcl-io-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-octree-1.7-dev, openni-dev, libvtk5-dev, libusb-1.0-0-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL io.

Package: libpcl-io-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ps-engine
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL io.

Package: libpcl-kdtree-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-kdtree-1.2-dev, libpcl-kdtree-1.3-dev, libpcl-kdtree-1.4-dev, libpcl-kdtree-1.5-dev, libpcl-kdtree-1.6-dev
Depends: libpcl-kdtree-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libflann-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL kdtree.

Package: libpcl-kdtree-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL kdtree.

Package: libpcl-keypoints-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-keypoints-1.2-dev, libpcl-keypoints-1.3-dev, libpcl-keypoints-1.4-dev, libpcl-keypoints-1.5-dev, libpcl-keypoints-1.6-dev
Depends: libpcl-keypoints-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev, libpcl-search-1.7-dev, libpcl-kdtree-1.7-dev, libpcl-octree-1.7-dev, libpcl-features-1.7-dev, libpcl-filters-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains development files needed to build applications depending on PCL keypoints.

Package: libpcl-keypoints-1.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Point Cloud Library (or PCL) for point cloud processing - runtime
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending on PCL keypoints.

Package: libpcl-octree-1.7-dev
Section: libdevel
Architecture: any
Conflicts: libpcl-octree-1.2-dev, libpcl-octree-1.3-dev, libpcl-octree-1.4-dev, libpcl-octree-1.5-dev, libpcl-octree-1.6-dev
Depends: libpcl-octree-1.7 (= ${binary:Version}), ${misc:Depends}, libpcl-common-1.7-dev
Description: The Point Cloud Library (or PCL) for point cloud processing - development
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
