=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@ --parallel --builddirectory=build

override_dh_auto_build-indep:
	$(MAKE) -C build doc

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DCMAKE_SKIP_RPATH=ON						\
	-DBUILD_apps=ON
